#pragma once

#include <vector>
#include <memory>
#include "u.hpp"
#include "mesh.hpp"
#include "camera.hpp"
#include "entity.hpp"
#include <SDL2/SDL.h>
#include <glad.h>

struct Game
{
    SDL_Window *window;
    SDL_GLContext context;
    u32 win_flags;
    u32 win_width;
    u32 win_height;

    bool running;
    bool fullscreen;
    bool wireframe;

    std::vector<Entity*> entities;

    float rotation;
    Camera camera;

    Game();
    ~Game();
    void update(float dt);
    void render() const;
    Entity *add_entity();
    void toggle_fullscreen();
    void toggle_wireframe();
    SDL_Window *get_window() const;
};
