#version 330 core

layout (location = 0) in vec3 v;
layout (location = 1) in vec2 vt;
layout (location = 2) in vec3 vn;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

out vec3 normal;
out vec3 world_pos;
out vec3 vertex_col;

void
main()
{
    world_pos = vec3(model * vec4(v, 1.0));
    normal = mat3(transpose(inverse(model))) * vn;
    vertex_col = v / 2 + 0.5;

    gl_Position = projection * view * model * vec4(v, 1.0);
}
